#ifndef _main__inc__
#define _main__inc__

#define INCLUDE_BUGTESTS

enum NEWLINETAG
{
	NEWLINETAG_P = 0,
	NEWLINETAG_DIV,
	NEWLINETAG_BR
}

enum ONSIZEFLAG
{
	ONSIZEFLAG_NONE = 0,
	ONSIZEFLAG_TABCTL,
	ONSIZEFLAG_PROJECT
}

enum MAINFLAGS
{
	MAINFLAG_USE_BR_IN_PRE = 1,
	MAINFLAG_HIDE_TAB      = 2
}

#define DATAPATHA  "res://chmmaker.exe/"  // used also in InitMdiChild()
#define DATAPATHW L"res://chmmaker.exe/"

#ifndef _main_

extern g_WindowLockCount as int; // increment this to keep the window alive
extern g_sci           as HMODULE;
extern g_hriched       as HMODULE;
extern g_hwndApp       as HWND;
extern g_hwndLastFocus as HWND;
extern g_hwndToolbar   as HWND;
extern g_hwndMdi       as HWND;
extern g_hwndSbr       as HWND;
extern g_hwndFontFaces as HWND;
extern g_hwndFontSizes as HWND;
extern g_menu          as HMENU;
extern g_menuContext   as HMENU;
extern g_menuNew       as HMENU;
extern g_menuRiched    as HMENU;
extern g_menuInsert    as HMENU;
extern g_menuHtml      as HMENU;
extern g_NewlineTag    as NEWLINETAG;
extern g_accel         as HACCEL;
extern g_accel1        as HACCEL;
extern g_accel2        as HACCEL;
extern WM_FINDMSGSTRING as UINT;
//g_menuInsert             11000-11199
//g_menuHtml               11200-11299
//treeview                 11300-11399
//g_menuRecentProjects     12000-12999
//g_menuRecentFiles        13000-13999
//g_menuInsert->Templates  14000-14999
// menu tools              15000-15999
// shell menu              16000-16999

declare extern DisableHotkeys();
declare extern EnableHotkeys();
declare extern MessageBoxFromHresult(HRESULT hr, opt string *text = NULL);
declare extern __ApplyColor(DHTMLEDITCMDID cmdId);
declare extern OnSize(ONSIZEFLAG flags);
declare extern GetRelativePath(LPWSTR pwszFilePath, LPWSTR pwszRelPath, opt LPWSTR pwszRelativeTo=NULL);
declare extern PasteHtml(LPWSTR pwszText);
declare extern OnChildLoadedOrSaved(CHILWNDDATA *data, LPWSTR wszFilePath);
declare extern LoadFileIntoWindow(LPWSTR path, CHILWNDDATA *data,opt BOOL fWarn=TRUE);
declare extern GetChildTypeFromPath(LPWSTR path, CTRLTYPE *ppv);
declare extern GetCurrentElement(IHTMLDocument2 *ppDoc, IHTMLTxtRange *ppText, IHTMLControlRange *ppCtl),HRESULT;

declare extern menuFileOpenPage(opt LPWSTR path=NULL,opt BOOL fWarn=TRUE),HRESULT;
declare extern menuFileSave(opt CHILWNDDATA *data = NULL);
//declare extern menuFileReload();
//declare extern menuFilePrint();
//declare extern menuFilePrintPreview();
//declare extern menuFileSaveAs(opt CHILWNDDATA *data = NULL);

#endif

interface CMenuDisp
{
	// File
	declare virtual NewProject();
	declare virtual NewHtmlPage(),HWND;
	declare virtual NewEmptyHtmlPage(),HWND;
	declare virtual NewHtmlSource();
	declare virtual NewJavascript();
	declare virtual NewCss();
	declare virtual NewTxt();
	declare virtual Open();
	declare virtual Close();
	declare virtual Save();
	declare virtual SaveAs();
	declare virtual SaveAll();
	declare virtual OpenProject();
	declare virtual CloseProject();
	declare virtual SaveProject();
	declare virtual PrintDoc();
	declare virtual PrintPreview();
	declare virtual Exit();
	// View
	declare virtual Source();
	declare virtual Preview();
	declare virtual Details();
	declare virtual unused10022();
	declare virtual Properties();
	declare virtual Customize();
	// Edit
	declare virtual Undo();
	declare virtual Redo();
	declare virtual Cut();
	declare virtual Copy();
	declare virtual Paste();
	declare virtual SelectAll();
	declare virtual DeleteSel();
	declare virtual FindText();
	// Format
	declare virtual Bold();
	declare virtual Italic();
	declare virtual Underline();
	declare virtual Indent();
	declare virtual Outdent();
	declare virtual JustifyLeft();
	declare virtual JustifyCenter();
	declare virtual JustifyRight();
	declare virtual UseDIVOnCR();
	declare virtual UseBROnCR();
	declare virtual UsePOnCR();
	declare virtual AlwaysUseBRInCode();
	// Insert
	declare virtual Syntax();
	declare virtual Members();
	declare virtual Parameters();
	declare virtual Parameter();
	declare virtual ReturnValue();
	declare virtual Remarks();
	declare virtual ExampleCode();
	declare virtual SeeAlso();
	declare virtual Requirements();
	declare virtual NewLine();
	declare virtual HTMLCode();
	declare virtual Code();
	declare virtual Table();
	// Insert HTML Element - another menu 11001
	// Tools - another menu 15000
	// Windows
	declare virtual NewWindow();
	declare virtual Cascade();
	declare virtual TileHorizontal();
	declare virtual TileVertical();
	declare virtual ArrangeIcons();
}

interface CToolbarDisp
{
	declare virtual NewHtmlPage(),HWND;
	declare virtual Open();
	declare virtual Reload();
	declare virtual Save();	
	declare virtual SaveAll();
	declare virtual Cut();
	declare virtual Copy();
	declare virtual Paste();
	declare virtual Undo();
	declare virtual Redo();
	declare virtual FindText();
	declare virtual PrintDoc();
	declare virtual Indent();
	declare virtual Outdent();
	declare virtual JustifyLeft();
	declare virtual JustifyCenter();
	declare virtual JustifyRight();
	declare virtual Bold();
	declare virtual Italic();
	declare virtual Underline();
	declare virtual ForeColor();
	declare virtual BackColor();
	declare virtual Font();
	declare virtual Bookmark();
	declare virtual Anchor();
	declare virtual Image();
}

#ifndef _main_
extern *menuDispatcher as CMenuDisp;
extern *toolbarDispatcher as CToolbarDisp;
#endif

#endif





