#ifndef _mdichild__inc__
#define _mdichild__inc__

#include "dhtmled.inc"
#include "DHTMLEditEvents.inc"
#include "CScintilla.inc"
#include "mshtml.inc"
#include "dhtmled.inc"

const MDIARRAYSIZE = 128; // GetChildArray

enum CTRLTYPE
{
	CTRLTYPE_HTMLEDIT = 1,
	CTRLTYPE_HTML,
	CTRLTYPE_CSS,
	CTRLTYPE_JS,
	CTRLTYPE_TXT
}

#ifndef _mdichild_
// CreateNewChild will create new MDI child window with the control
// specified by CTRLTYPE
declare extern CreateNewChild(CTRLTYPE type, opt int left=CW_USEDEFAULT,opt int top=CW_USEDEFAULT,opt int width=CW_USEDEFAULT,opt int height=CW_USEDEFAULT,opt int style=0),HWND;
declare extern CloseChild(HWND hwnd);
declare extern DestroyChild(HWND hwnd);
// ChildMsgProc is the message handler for MDI child windows
declare extern ChildMsgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam),LRESULT;
declare extern GetChildData(HWND hwndChild, CHILWNDDATA *ppv),BOOL;
declare extern GetActiveIDHTMLEdit(IDHTMLEdit *ppv),HRESULT;
declare extern GetActiveDom(IHTMLDocument2 *ppv),HRESULT;
declare extern GetActiveCommandTarget(IOleCommandTarget *ppv),HRESULT;
declare extern UpdateMdiChildTitle(opt CHILWNDDATA *data=NULL);
declare extern ActivateChildByPath(LPWSTR path),BOOL; // path can be NULL
declare extern FindChildByPath(LPWSTR path, CHILWNDDATA *ppv),BOOL;
declare extern GetChildArray(HWND *ppArray, int *ppCount),int;
declare extern ChildIsModified(CHILWNDDATA *data),BOOL;
declare extern ChildSavePrompt(CHILWNDDATA *data,opt BOOL *pCancel=NULL);
declare extern ChildSetDefaultIcon(CHILWNDDATA *data);
declare extern OnFindReplace(FINDREPLACE *pfr);
// text selection
declare extern ChildGetTextSelection(CHILWNDDATA *data,int *ppStart, int *ppEnd);
declare extern ChildSetTextSelection(CHILWNDDATA *data,int nStart, int nEnd);
declare extern ChildGetTextLength(CHILWNDDATA *data, int *ppLen);

extern WC_CHILD    as string;
extern g_hwndChild as HWND;

#endif

// CHILWNDDATA is allocated for every MDI child window, and stored in "CHILWNDDATA" property.
// use GetChildData to retriee pointer to this structure.
// CHILWNDDATA is deleted when MDI child is closing.
// The .type parameter determines the kind of MDI child.
//   CTRLTYPE_HTMLEDIT - this is a Wysiwyg HTML editor, valid members: edit,handler,hwndChild,type.
//   CTRLTYPE_HTML     - html source editor, valid members: edit,sci,handler,hwndChild,type.
//   CTRLTYPE_CSS      - TODO


class CHILWNDDATA
{
	IDHTMLEdit        *edit;
	DHTMLEditEvents   *handler;
	CScintilla        *sci;
	HWND               hwnd;
	HWND               hwndChild;
	CTRLTYPE           type;
	BSTR               bstrPath;
	HICON              hiconSm;
	// find text
	FINDREPLACE        find;
	HWND               hwndFind;
	dstring            szFind[256];
	// planned
	IHTMLDocument2    *document;
	IOleCommandTarget *cmdt;
	// relative path for resources
	dstring            szDataPath[MAX_PATH];
}

#endif
